%define ALD_Ver		2.0

Name:         midori

License:      LGPL
Summary:      Midori is a lightweight web browser.
Version:      0.5.12
Release:      3

Source: %{name}-0.5.11.tar.xz
Source2: %{name}-%{version}-3-patches.tar.xz

%define DestDir		/Gtk3/3.0
# -----------------------------------------------------

%if %{_target_cpu} == %{_build_cpu}
%define _srcrpmdir	%{_topdir}/SRPMS/%{ALD_Ver}
%define _CROSS 0
%define MakeLocCross 0
%else
# rpm --target=armv7hl -ba xxxxx.spec
%define _srcrpmdir	%{_topdir}/SRPMS/tmp
%define _CROSS 1
%define MakeLocCross 1
%define _host %{_arch}-%{_os}%{_gnu}
%endif

#------------------ CROSS DIR --------------------

%define docdir		%{_defaultdocdir}/%{name}

%define auto_local %{_sourcedir}/AUTO_LOCAL-1.sh
%define have_auto_local %(if test -x %{auto_local} ; then echo 1 ; else echo 0 ; fi)

%if %{have_auto_local}
%define __os_install_post %{nil}
%define CrossPath	%(%{auto_local} -GetCrossPath -build_cpu=%{_build_cpu} -target_cpu=%{_target_cpu})
%endif

# ------------------- description ------------------------------------
%description
Midori is a lightweight web browser.
#-------------------------------
%package svg_icons
Summary:      scalable svg icons
%description svg_icons
scalable svg icons
#-------------------------------
%package locale
Summary:      locale
%description locale
Locale

# ------------------- setup ------------------------------------------
%Prep
%setup -q -n %{name}-0.5.11

sed -i s:" -g":: CMakeLists.txt
sed -i s:"-g -fPIC":"-fPIC": CMakeLists.txt

tar -xaf %SOURCE2
patch -p1<patches/midori-0.5.12-20160321.patch
patch -p1<patches/midori-0.5.12-20160905.patch
patch -p0<patches/misc.patch
patch -p0<patches/v2/html_save_all.patch
patch -p0<patches/v3/app_id.patch
patch -p0<patches/v3/logfile.patch
patch -p0<patches/v3/skip_deprecated.patch

# ------------------- Build ------------------------------------------
%Build
%if %{_CROSS}
export PATH="%{CrossPath}/bin:$PATH"
export GCC_NoHostPath=d
%endif

%if %{_arch} == "i386"
OPTFLAGS="-O2 -march=i586 -ffast-math -falign-functions=4 -falign-jumps=1 -falign-loops=1 -fomit-frame-pointer"
%endif
%if %{_arch} == "x86_64"
OPTFLAGS="-O2 -ffast-math"
%endif
%if %{_arch} == "arm"
OPTFLAGS="%{optflags} -O2 -munaligned-access"
%endif

OPTFLAGS="$OPTFLAGS -ffunction-sections -fdata-sections -fno-asynchronous-unwind-tables -fno-stack-protector"

CFLAGS="$OPTFLAGS -std=gnu99"
CXXFLAGS="$OPTFLAGS"
LDFLAGS="-Wl,--gc-sections -L/usr/X11/%{_lib}"

rm -rf _Build
mkdir _Build

pushd _Build

cmake \
  -DCMAKE_INSTALL_PREFIX=%{_prefix} \
  -DCMAKE_INSTALL_SYSCONFDIR=/etc \
  -DCMAKE_INSTALL_LIBDIR=%{_libdir} \
  -DCMAKE_BUILD_TYPE=Release \
  -DCMAKE_VERBOSE_MAKEFILE:BOOL=ON \
  -DUSE_GTK3=1 \
  -DUSE_ZEITGEIST=0 \
  .. &>FConfigure_log.txt

make &>FMake_log.txt

popd

# ------------------- Install ----------------------------------------
%Install
%if %{_CROSS}
export  PATH="%{CrossPath}/bin:$PATH"
export GCC_NoHostPath=d
%endif

rm -rf $RPM_BUILD_ROOT
mkdir -p %{_srcrpmdir}

cd _Build
make DESTDIR=$RPM_BUILD_ROOT install &>FInstall_log.txt
cd ..

mv $RPM_BUILD_ROOT/etc/xdg/midori/extensions/adblock/config $RPM_BUILD_ROOT/etc/xdg/midori/extensions/adblock/config.default

mkdir -p $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/16x16/mimetypes
cp -a patches/v3/java_16x16.png $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/16x16/mimetypes/text-x-javascript.png
mkdir -p $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/24x24/mimetypes
cp -a patches/v3/java_24x24.png $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/24x24/mimetypes/text-x-javascript.png
mkdir -p $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/32x32/mimetypes
cp -a patches/v3/java_32x32.png $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/32x32/mimetypes/text-x-javascript.png


if test -x /usr/bin/rsvg-convert; then
pushd $RPM_BUILD_ROOT%{_datadir}/icons/hicolor
  mv 24x24/status/adblock-*.svg scalable/status/
  for i in 16 22 24; do
    rsvg-convert -w $i -h $i -o ${i}x${i}/status/adblock-blocked.png scalable/status/adblock-blocked.svg
    rsvg-convert -w $i -h $i -o ${i}x${i}/status/adblock-disabled.png scalable/status/adblock-disabled.svg
    rsvg-convert -w $i -h $i -o ${i}x${i}/status/adblock-enabled.png scalable/status/adblock-enabled.svg
  done

  mkdir -p 24x24/apps
  rsvg-convert -w 24 -h 24 -o 24x24/apps/midori.png scalable/apps/midori.svg
  mkdir -p 32x32/apps
  rsvg-convert -w 32 -h 32 -o 32x32/apps/midori.png scalable/apps/midori.svg
  mkdir -p 48x48/apps
  rsvg-convert -w 48 -h 48 -o 48x48/apps/midori.png scalable/apps/midori.svg

  mkdir -p 24x24/categories
  rsvg-convert -w 24 -h 24 -o 24x24/categories/extension.png scalable/categories/extension.svg
  rsvg-convert -w 24 -h 24 -o 24x24/status/internet-news-reader.png scalable/status/internet-news-reader.svg
popd
fi

/usr/lib/rpm/check-rpaths

%if %{have_auto_local}
  %{auto_local} -build_cpu=%{_build_cpu} -target_cpu=%{_target_cpu} \
	-MakeLocCross=%{MakeLocCross} -DelLocCrossDir=%{_bindir}
%endif  # have_auto_local
# ------------------- Clean ------------------------------------------
%Clean

%if %{have_auto_local}
  %{auto_local} -build_cpu=%{_build_cpu} -target_cpu=%{_target_cpu} \
	-MakeLocCross=%{MakeLocCross} \
	-ALD_Ver=%{ALD_Ver} -RpmMovePath=%{DestDir} -tar_arg=bzip2
%endif  # have_auto_local

# ------------------- Post- ------------------------------------------
%posttrans
if test -d $HOME/.ALDccp/Menu/StartMenu/Programs; then
  if test ! -d $HOME/.ALDccp/Menu/StartMenu/Programs/Network; then
    mkdir -p $HOME/.ALDccp/Menu/StartMenu/Programs/Network
    printf "[Desktop Entry]\nType=Directory\nName=Network\nIcon=network\n" >$HOME/.ALDccp/Menu/StartMenu/Programs/Network/.directory
    printf "[Desktop Entry]\nType=Application\nName=Midori\nExec=su fred -c \"/bin/bash -l -c midori\"\nIcon=midori\n" >$HOME/.ALDccp/Menu/StartMenu/Programs/Network/midori.desktop
    printf "[Desktop Entry]\nType=Application\nName=Midori\nMimeType=text/html;application/xhtml+xml;x-scheme-handler/http;x-scheme-handler/https;x-scheme-handler/geo;image/svg+xml;\nExec=midori -p %%%%U\nIcon=midori\n" >$HOME/.ALDccp/share/applications/midori.desktop
  fi
fi

if test -d $HOME/.ALDccp/Desktop; then
  printf "[Desktop Entry]\nType=Application\nName=Midori\nExec=su fred -c \"/bin/bash -l -c midori\"\nIcon=midori\n" >$HOME/.ALDccp/Desktop/midori.desktop
fi

if test ! -e /etc/xdg/midori/extensions/adblock/config; then
  cp /etc/xdg/midori/extensions/adblock/config.default /etc/xdg/midori/extensions/adblock/config
fi

%postun
if test "$1" = "0" ; then
  rm -f $HOME/.ALDccp/Menu/StartMenu/Programs/Network/midori.desktop
  if test -z "$(ls -A $HOME/.ALDccp/Menu/StartMenu/Programs/Network/*.desktop 2>/dev/null)"; then
    rm -rf $HOME/.ALDccp/Menu/StartMenu/Programs/Network
  fi

  rm -f $HOME/.ALDccp/Desktop/midori.desktop
  rm -f $HOME/.ALDccp/share/applications/midori.desktop
fi
# ------------------- Files ------------------------------------------
%files
%{_sysconfdir}/xdg/midori/extensions/adblock/config.default
%{_sysconfdir}/xdg/midori/search
%{_bindir}
%{_libdir}
%{_datadir}/appdata
%{_datadir}/applications
%{_datadir}/doc/midori
%{_datadir}/icons/hicolor/16x16
%{_datadir}/icons/hicolor/22x22
%{_datadir}/icons/hicolor/24x24
%{_datadir}/icons/hicolor/32x32
%{_datadir}/icons/hicolor/48x48
%{_datadir}/midori

%files svg_icons
%{_datadir}/icons/hicolor/scalable

%files locale
%{_datadir}/locale
